package gp_dbc.system;

import org.lwjgl.Sys;

import java.util.List;
import java.util.UUID;

import static gp_dbc.config.ConfigManager.TIME_TO_GO_IN_JAIL;

public class Handcuffed {

    public long start_time;

    public UUID inmate;
    public UUID jailer;

    public static long timeToWait = TIME_TO_GO_IN_JAIL;

    public Handcuffed(UUID inmate, long start_time) {
        this(inmate, null, start_time);
    }

    public Handcuffed(UUID inmate, UUID jailer, long start_time) {
        this.inmate = inmate;
        this.jailer = jailer;
        this.start_time = start_time;
    }

    public boolean equals(UUID inmate) {
        return this.inmate == inmate;
    }

    public boolean equals(UUID inmate, long start_time) {
        return this.inmate == inmate && this.start_time == start_time;
    }

    public boolean equals(UUID inmate, UUID jailer, long start_time) {
        return this.inmate == inmate && this.start_time == start_time && this.jailer == jailer;
    }

    public static boolean contains_handcuffed(List<Handcuffed> handcuffeds, UUID inmate) {
        return contains_handcuffed(handcuffeds, inmate, null);
    }

    public static boolean contains_handcuffed(List<Handcuffed> handcuffeds, UUID inmate, Long start_time) {
        return contains_handcuffed(handcuffeds, inmate, null, null);
    }

    public static boolean contains_handcuffed(List<Handcuffed> handcuffeds, UUID inmate, UUID jailer, Long start_time) {
        for (Handcuffed hdfd : handcuffeds) {
            if (start_time == null && jailer == null) {
                if (hdfd.equals(inmate))
                    return true;
            }
            else if (start_time == null) {
                if (hdfd.equals(inmate, start_time))
                    return true;
            }
            else
                if (hdfd.equals(inmate, jailer, start_time))
                    return true;
        }

        return false;
    }
}
